// *********** basic.cpp ***********
// implementations of class basic:: (basic functions)
//
#ifdef __BCPLUSPLUS__
#include <vcl.h>
#endif
#include "basic.h"

using namespace std;

void basic::error(int code,char *message) // prints error message
					    // no use to code at this moment of implementation
{
    strcpy(this->error_text,message);
#ifdef __BCPLUSPLUS__
    Application->MessageBox(error_text,"Error",0);
#endif
#ifdef STDOUT
    cerr << message << endl;
#endif
}

void basic::move(void *from, void *to, int count)
{
#ifdef DEBUG
#ifdef STDOUT
    cout<<"DEBUG: starting basic::move() with count="<<count<<endl;
#endif
#endif

    char *sfrom=(char*) from;
    char *sto=(char*) to;
    for(int i=0;i<count;i++)
    {
	sto[i]=sfrom[i];
#ifdef DEBUG
#ifdef STDOUT
	cout<<(short)sto[i]<<"|";
#endif
#endif
    }
#ifdef DEBUG
#ifdef STDOUT
    cout<<endl;
#endif
#endif
}

void basic::itoa(int num, char *to)
{
#ifdef DEBUG
#ifdef STDOUT
    cout<<"DEBUG: starting itoa with num="<<num<<endl;
#endif
#endif
    sprintf(to,"%d",num);
}

int basic::count_sym(const char *s,const char c)
{
    int count=0;
    for(unsigned int i=0;i<strlen(s);i++)
	if(s[i]==c)
	    count++;
    return count;
}

